# Generated by the gRPC Python protocol compiler plugin. DO NOT EDIT!
"""Client and server classes corresponding to protobuf-defined services."""
import grpc

from google.protobuf import empty_pb2 as google_dot_protobuf_dot_empty__pb2
from ryax_execution import execution_v3_pb2 as ryax__execution_dot_execution__v3__pb2


class ActionExecutionStub(object):
    """Manage Ryax Action executions
    """

    def __init__(self, channel):
        """Constructor.

        Args:
            channel: A grpc.Channel.
        """
        self.Init = channel.unary_unary(
                '/execution_v3.ActionExecution/Init',
                request_serializer=ryax__execution_dot_execution__v3__pb2.InitRequest.SerializeToString,
                response_deserializer=ryax__execution_dot_execution__v3__pb2.InitReply.FromString,
                )
        self.Run = channel.stream_stream(
                '/execution_v3.ActionExecution/Run',
                request_serializer=ryax__execution_dot_execution__v3__pb2.RunRequest.SerializeToString,
                response_deserializer=ryax__execution_dot_execution__v3__pb2.RunReply.FromString,
                )
        self.Version = channel.unary_unary(
                '/execution_v3.ActionExecution/Version',
                request_serializer=google_dot_protobuf_dot_empty__pb2.Empty.SerializeToString,
                response_deserializer=ryax__execution_dot_execution__v3__pb2.VersionReply.FromString,
                )


class ActionExecutionServicer(object):
    """Manage Ryax Action executions
    """

    def Init(self, request, context):
        """Initialize action before execution. Should be called only once.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def Run(self, request_iterator, context):
        """Run a new execution
        Stream inputs one by one, or even chunk by chunk for inputs that may exceed 4MB
        Returns one (or more) execution results
        Each output is streamed one by one. Metadata is sent on the last message (last_reply_of_this_run==True)
        that does not contain any data.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def Version(self, request, context):
        """Missing associated documentation comment in .proto file."""
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')


def add_ActionExecutionServicer_to_server(servicer, server):
    rpc_method_handlers = {
            'Init': grpc.unary_unary_rpc_method_handler(
                    servicer.Init,
                    request_deserializer=ryax__execution_dot_execution__v3__pb2.InitRequest.FromString,
                    response_serializer=ryax__execution_dot_execution__v3__pb2.InitReply.SerializeToString,
            ),
            'Run': grpc.stream_stream_rpc_method_handler(
                    servicer.Run,
                    request_deserializer=ryax__execution_dot_execution__v3__pb2.RunRequest.FromString,
                    response_serializer=ryax__execution_dot_execution__v3__pb2.RunReply.SerializeToString,
            ),
            'Version': grpc.unary_unary_rpc_method_handler(
                    servicer.Version,
                    request_deserializer=google_dot_protobuf_dot_empty__pb2.Empty.FromString,
                    response_serializer=ryax__execution_dot_execution__v3__pb2.VersionReply.SerializeToString,
            ),
    }
    generic_handler = grpc.method_handlers_generic_handler(
            'execution_v3.ActionExecution', rpc_method_handlers)
    server.add_generic_rpc_handlers((generic_handler,))


 # This class is part of an EXPERIMENTAL API.
class ActionExecution(object):
    """Manage Ryax Action executions
    """

    @staticmethod
    def Init(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/execution_v3.ActionExecution/Init',
            ryax__execution_dot_execution__v3__pb2.InitRequest.SerializeToString,
            ryax__execution_dot_execution__v3__pb2.InitReply.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def Run(request_iterator,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.stream_stream(request_iterator, target, '/execution_v3.ActionExecution/Run',
            ryax__execution_dot_execution__v3__pb2.RunRequest.SerializeToString,
            ryax__execution_dot_execution__v3__pb2.RunReply.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def Version(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/execution_v3.ActionExecution/Version',
            google_dot_protobuf_dot_empty__pb2.Empty.SerializeToString,
            ryax__execution_dot_execution__v3__pb2.VersionReply.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)
